/* Generated test code to dump a table of data for external validation
 * of the noise model parameters.
 */
#include <stdio.h>
#include <assert.h>
double compute_noise_model_entry_S(int plane, int sens);
double compute_noise_model_entry_O(int plane, int sens);
int main(void) {
    for (int plane = 0; plane < 4; plane++) {
        for (int sens = 50; sens <= 3200; sens += 100) {
            double o = compute_noise_model_entry_O(plane, sens);
            double s = compute_noise_model_entry_S(plane, sens);
            printf("%d,%d,%lf,%lf\n", plane, sens, o, s);
        }
    }
    return 0;
}

/* Generated functions to map a given sensitivity to the O and S noise
 * model parameters in the DNG noise model. The planes are in
 * R, Gr, Gb, B order.
 */
double compute_noise_model_entry_S(int plane, int sens) {
    static double noise_model_A[] = { 3.1817478908625644e-07,3.207914091849103e-07,3.2041106491528823e-07,3.190207595461657e-07 };
    static double noise_model_B[] = { 3.659184309088073e-07,2.0159873208674143e-06,2.2754306007256886e-06,7.032548111281313e-07 };
    double A = noise_model_A[plane];
    double B = noise_model_B[plane];
    double s = A * sens + B;
    return s < 0.0 ? 0.0 : s;
}

double compute_noise_model_entry_O(int plane, int sens) {
    static double noise_model_C[] = { 2.6031766243880773e-13,2.803777738985254e-13,2.86022201982769e-13,2.781818453238125e-13 };
    static double noise_model_D[] = { 6.95441523543248e-07,6.477294501269858e-07,6.494949950841822e-07,6.86812657026818e-07 };
    double digital_gain = (sens / 800.0) < 1.0 ? 1.0 : (sens / 800.0);
    double C = noise_model_C[plane];
    double D = noise_model_D[plane];
    double o = C * sens * sens + D * digital_gain * digital_gain;
    return o < 0.0 ? 0.0 : o;
}
